use std::fs::File;
use std::io::{BufRead, BufReader};
use std::collections::HashMap;

#[derive(Debug)]
struct tm_data {
    idx: String,
    val: f32,
    timestamp_s: u64,
    date: String,
    time: String,
}

impl tm_data {
    pub fn new(idx: String, val: f32, timestamp_s: u64, date: String, time: String) -> tm_data {
        tm_data { idx, val, timestamp_s, date, time }
    } 
}


fn main() {
    let mut buf_raw_sens: Vec<String> = Vec::new();
    let mut data = File::open("data.txt").unwrap();
    let mut tm_data_v: [Vec<tm_data>; 4] = [Vec::new(), Vec::new(), Vec::new(), Vec::new()];

    let reader = BufReader::new(data);

    let buf_all: Vec<String> = reader.lines()
        .map(|line| line.expect("error"))
        .collect();

    let mut tm_idx = Vec::new();
    tm_idx.push("T1MBH");
    tm_idx.push("T2MBH");
    tm_idx.push("T3MBH");
    tm_idx.push("T4MBH");

    let mut val: Vec<String> = Vec::new();

    for elem in buf_all {
        for (i, idx) in tm_idx.clone().into_iter().enumerate() {
            if elem.contains(idx)
            {
                val = elem.split_whitespace()
                    .map(|elem| elem.parse::<String>().unwrap())
                    .collect();

                let temp = tm_data::new(idx.to_string(), val[1].parse::<f32>().unwrap(), 0, 
                                    val[4].clone(), val[5].clone());

                println!("{:#?}", temp);

                tm_data_v[i].push(temp);

                buf_raw_sens.push(elem.clone());
            }
        } 
    }

    let val1: Vec<String> = buf_raw_sens[0]
        .split_whitespace()
        .map(|elem| elem.parse::<String>().unwrap())
        .collect();

    println!("{:#?}", tm_data_v[0]);
}
